﻿using System;

namespace Dekorator
{
    using UMK.WzorceStrukturalne;

    class Program
    {
        private static void wyświetlOpisNapoju(Napój napój)
        {
            Console.WriteLine(napój.ToString());
            Console.WriteLine($"Cena: {napój.Cena()} zł");
        }

        static void Main(string[] args)
        {
            Napój napój;            

            bool kawaCzyHerbata = false;
            if(kawaCzyHerbata) napój = new Kawa();
            else napój = new Herbata();
            wyświetlOpisNapoju(napój);

            bool czyCynamon = true;
            if (czyCynamon) napój = new NapójZeSzczyptąCynamonu(napój);
            wyświetlOpisNapoju(napój);

            int ileŁyżeczekCukru = 2;
            if (ileŁyżeczekCukru > 0)
            {
                for (int i = 0; i < ileŁyżeczekCukru; i++)
                    napój = new NapójZŁyżeczkąCukru(napój);
            }
            wyświetlOpisNapoju(napój);

            uint ilePlasterkówCytryny = 1;
            if(ilePlasterkówCytryny > 0)
            {
                napój = new NapójZCytryną(napój, ilePlasterkówCytryny);
            }
            wyświetlOpisNapoju(napój);

            Napój kawa = new NapójZŁyżeczkąCukru(
                new NapójZŁyżeczkąCukru(
                    new NapójZeSzczyptąCynamonu(
                        new Kawa())));
            wyświetlOpisNapoju(kawa);
        }
    }
}
